super: no superclass method `load_defaults' for #<Class:0x00000003762b60> (NoMethodError)
Description

My foreman install gives this error when browsing to any page:

Message from application: super: no superclass method `load_defaults' for #<Class:0x00000003762b60

> (NoMethodError)

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/dynamic_matchers.r

b:55:in `method_missing'

  /usr/share/foreman/app/models/setting/puppet.rb:5:in `load_defaults'

  /usr/share/foreman/config/initializers/foreman.rb:18:in `each'

  /usr/share/foreman/config/initializers/foreman.rb:18:in `<top (required)>'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

245:in `load'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

245:in `block in load'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

236:in `load_dependency'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

245:in `load'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/engine.rb:588:in `block (2 lev

els) in <class:Engine>'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/engine.rb:587:in `each'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/engine.rb:587:in `block in <cl

ass:Engine>'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:30:in `instan

ce_exec'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:30:in `run'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:55:in `block 

in run_initializers'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:54:in `each'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:54:in `run_in

itializers'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/application.rb:136:in `initial

ize!'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/railtie/configurable.rb:30:in 

`method_missing'

  /usr/share/foreman/config/environment.rb:5:in `<top (required)>'

  /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

  /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

  config.ru:3:in `block in <main>'

  /opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/builder.rb:51:in `instance_eval'

  /opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/builder.rb:51:in `initialize'

  config.ru:1:in `new'

  config.ru:1:in `<main>'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.52/helper-scripts/rack-preloader.rb:112:in `eval'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.52/helper-scripts/rack-preloader.rb:112:in `preload_ap

p'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.52/helper-scripts/rack-preloader.rb:158:in `<module:Ap
p>'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.52/helper-scripts/rack-preloader.rb:29:in `<module:Phu

sionPassenger>'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.52/helper-scripts/rack-preloader.rb:28:in `<main>'

 

Here is my passenger apache conf:

LoadModule passenger_module /usr/lib/ruby/gems/1.8/gems/passenger-4.0.52/buildout/apache2/mod_pass

enger.so

   <IfModule mod_passenger.c>

     PassengerRoot /usr/lib/ruby/gems/1.8/gems/passenger-4.0.52

     PassengerDefaultRuby /usr/bin/ruby

   </IfModule>

PassengerHighPerformance on

PassengerUseGlobalQueue on

PassengerMaxPoolSize 6

#PassengerMaxRequests 1000

#PassengerPoolIdleTime 600

h3. Here is my apache foreman.conf:  

Listen 3000

<VirtualHost *:3000>

    ServerName amlnx-ppp-ppt01.pressplus.cloudha.rrdha.int

    SSLEngine on

        SSLProtocol -ALL +SSLv3 +TLSv1

        SSLCipherSuite ALL:!ASH:RC4+RSA:+HIGH:+MEDIUM:-LOW:-SSLv2:-EXP

        SSLCertificateFile /var/lib/puppet/ssl/certs/obfuscated.pem

        SSLCertificateKeyFile /var/lib/puppet/ssl/private_keys/obfuscated.pem

        SSLCertificateChainFile /var/lib/puppet/ssl/certs/ca.pem

        SSLCACertificateFile /var/lib/puppet/ssl/ca/ca_crt.pem

        SSLCARevocationFile /var/lib/puppet/ssl/ca/ca_crl.pem

        SSLVerifyClient optional

        SSLVerifyDepth 1

        SSLOptions +StdEnvVars

    RequestHeader set X-SSL-Subject %{SSL_CLIENT_S_DN}e

    RequestHeader set X-Client-DN %{SSL_CLIENT_S_DN}e

    RequestHeader set X-Client-Verify %{SSL_CLIENT_VERIFY}e

    DocumentRoot /usr/share/foreman/public/

    PassengerAppRoot /usr/share/foreman

    PassengerRuby /usr/bin/ruby193-ruby

    PassengerMinInstances 1

    AddDefaultCharset UTF-8

    <Directory /usr/share/foreman/public/>

        Options None

        AllowOverride AuthConfig

        Order allow,deny

        allow from all

    </Directory>

    ErrorLog /var/log/httpd/foreman_error.log

    LogLevel debug

    CustomLog /var/log/httpd/foreman_access.log combined

    ServerSignature On

</VirtualHost>

 I can provide any additional information needed. I did check the issue list and Google first but could not find enough info to help

myself. Assistance much appreciated.

History

#1 - 10/10/2014 11:07 AM - Dominic Cleal
Strange error, it looks like the "Setting" class we ship (/usr/share/foreman/app/models/setting.rb) is either:

1. Corrupt copy of setting.rb, use rpm -qfV /usr/share/foreman/app/models/setting.rb to verify

2. Some other library or plugin installed that's eclipsing "Setting" with its own class of the same name, but I've not seen this.  Perhaps look at scl

enable ruby193 'gem list' to see if there's anything you've added there that shouldn't be installed.

#2 - 10/10/2014 11:07 AM - Dominic Cleal

- Status changed from New to Feedback

#3 - 10/10/2014 11:33 AM - Roderick Day

Dominic Cleal wrote:

Strange error, it looks like the "Setting" class we ship (/usr/share/foreman/app/models/setting.rb) is either:

1. Corrupt copy of setting.rb, use rpm -qfV /usr/share/foreman/app/models/setting.rb to verify

2. Some other library or plugin installed that's eclipsing "Setting" with its own class of the same name, but I've not seen this.  Perhaps look at

scl enable ruby193 'gem list' to see if there's anything you've added there that shouldn't be installed.

 Dominic,

Thanks for looking into this for me.

Here is the output of:  rpm -qfV /usr/share/foreman/app/models/setting.rb

# rpm -qfV /usr/share/foreman/app/models/setting.rb

S.5....T.  c /etc/foreman/database.yml

S.5....T.  c /etc/foreman/settings.yaml

S.5....T.  c /etc/sysconfig/foreman

 and here is the output of: scl enable ruby193 'gem list'

# scl enable ruby193 'gem list'

*** LOCAL GEMS ***

actionmailer (3.2.8)

actionpack (3.2.8)

activemodel (3.2.8)

activerecord (3.2.8)

activeresource (3.2.8)

activesupport (3.2.8)

ancestry (2.0.0)

apipie-rails (0.1.2)

arel (3.0.2)

audited (3.0.0)

audited-activerecord (3.0.0)

bigdecimal (1.1.0)

bootstrap-sass (3.0.3.0)

builder (3.0.0)

bundler (1.3.5)

bundler_ext (0.3.0)

daemons (1.1.4)

deep_cloneable (1.6.0)

diff-lcs (1.1.3)

erubis (2.7.0)

eventmachine (0.12.10)

excon (0.32.1)

execjs (1.4.0)

fast_gettext (0.8.0)

fog (1.21.0)

fog-brightbox (0.0.1)

fog-core (1.21.1)

fog-json (1.0.0)

foreigner (1.4.2)

formatador (0.2.1)

gettext_i18n_rails (0.10.0)

gettext_i18n_rails_js (0.0.8)

hike (1.2.1)

i18n (0.6.0)

i18n_data (0.2.7)

io-console (0.3)

journey (1.0.4)

jquery-rails (2.0.2)
jquery-ui-rails (4.0.2)

json (1.5.5)

mail (2.4.4)

mime-types (1.19)

multi_json (1.8.2)

mysql2 (0.3.11)

net-http-persistent (2.7)

net-ldap (0.3.1)

net-scp (1.1.0)

net-ssh (2.6.7)

netrc (0.7.7)

nokogiri (1.5.11)

oauth (0.4.7)

passenger (4.0.18)

po_to_json (0.0.7)

polyglot (0.3.3)

rabl (0.9.0)

rack (1.4.1)

rack-cache (1.2)

rack-ssl (1.3.2)

rack-test (0.6.1)

rails (3.2.8)

railties (3.2.8)

rake (0.9.2.2)

rdoc (3.9.5)

ref (1.0.0)

rest-client (1.6.7)

ruby2ruby (2.0.1)

ruby_parser (3.1.1)

safemode (1.2.1)

sass (3.2.13)

scoped_search (2.7.1)

sexp_processor (4.1.3)

sprockets (2.4.5)

therubyracer (0.11.0beta5)

thin (1.3.1)

thor (0.18.1)

tilt (1.3.3)

treetop (1.4.10)

twitter-bootstrap-rails (2.2.6)

tzinfo (0.3.33)

unf (0.1.3)

unf_ext (0.0.6)

uuidtools (2.1.3)

will_paginate (3.0.2)

#4 - 11/08/2014 09:49 PM - Roderick Day

THis may be closed.  THe underlying DB for the foreman was full.  CLeaning it out resolved the issue.

#5 - 11/10/2014 04:15 AM - Dominic Cleal

- Status changed from Feedback to Resolved

Wow, obscure result.  Glad you solved it!
